// Copyright (c) 2009 ochakko lab http://www5d.biglobe.ne.jp/~ochikko  All rights reserved.

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// ̃t@C͎RɉςĂ܂܂񂪉ςꍇ̓T|[gOłBŃfobOĂB
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

//////////////////////////
// texture
//////////////////////////
texture Texture0;
sampler Samp0Linear = sampler_state
{
    Texture = <Texture0>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU = Clamp;
    AddressV = Clamp;
};
sampler Samp0Point = sampler_state
{
	Texture = <Texture0>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = NONE;
    AddressU = Clamp;
    AddressV = Clamp;
};

texture Texture1;
sampler Samp1Linear = sampler_state
{
    Texture = <Texture1>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU = Clamp;
    AddressV = Clamp;
};
sampler Samp1Point = sampler_state
{
	Texture = <Texture1>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = NONE;
    AddressU = Clamp;
    AddressV = Clamp;
};

texture Texture2;
sampler Samp2Linear = sampler_state
{
    Texture = <Texture2>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU = Clamp;
    AddressV = Clamp;
};
sampler Samp2Point = sampler_state
{
	Texture = <Texture2>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = NONE;
    AddressU = Clamp;
    AddressV = Clamp;
};

/////////////////////////////////
//// user߂ݒł萔
/////////////////////////////////
float2 avSampleOffsets[16];	// TvÖʒu
float4 avSampleWeights[16];	// TvȌd

float4 userFL4_0;
float4 userFL4_1;
float4 userFL4_2;
float4 userFL4_3;
float4 userFL4_4;
float4 userFL4_5;
float4 userFL4_6;
float4 userFL4_7;
float4 userFL4_8;
float4 userFL4_9;
	
texture usertex0;
texture usertex1;
texture usertex2;
texture usertex3;
texture usertex4;

//sampler ` ǉ( sesalt 2011.10 )
sampler SampUser0Point = sampler_state
{
	Texture = <usertex0>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = NONE;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler SampUser1Point = sampler_state
{
	Texture = <usertex1>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = NONE;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler SampUser2Point = sampler_state
{
	Texture = <usertex2>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = NONE;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler SampUser3Point = sampler_state
{
	Texture = <usertex3>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = NONE;
    AddressU = Wrap;
    AddressV = Wrap;
};
	
sampler SampUser4Point = sampler_state
{
	Texture = <usertex4>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = NONE;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler SampUser0Linear = sampler_state
{
    Texture = <usertex0>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU = Clamp;
    AddressV = Clamp;
};

sampler SampUser1Linear = sampler_state
{
    Texture = <usertex1>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler SampUser2Linear = sampler_state
{
    Texture = <usertex2>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler SampUser3Linear = sampler_state
{
    Texture = <usertex3>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler SampUser4Linear = sampler_state
{
    Texture = <usertex4>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU = Wrap;
    AddressV = Wrap;
};


//ǉ܂

///////////////////////////////////////////////////////

struct VSTEX1_OUTPUT
{
	float4 Pos			: POSITION;
	float2 Tex0			: TEXCOORD0;
};

struct VSTEX2_OUTPUT
{
	float4 Pos			: POSITION;
	float4 Diffuse		: COLOR0;
	float4 Specular		: COLOR1;
	float2 Tex0			: TEXCOORD0;
};

struct VSTEX4_OUTPUT
{
    float4 Pos			: POSITION;
	float2 Tex0			: TEXCOORD0;
	float2 Tex1			: TEXCOORD1;
	float2 Tex2			: TEXCOORD2;
	float2 Tex3			: TEXCOORD3;
};

struct VSTLV_OUTPUT
{
    float4  Pos     : POSITION;
    float4  Diffuse : COLOR0;
    float2  Tex0    : TEXCOORD0;
};


struct PS_OUTPUT
{
	float4 Color	: COLOR0;
};

///////////////////////

// ------------------------------------------------------------
// _VF[_vO
// ------------------------------------------------------------

VSTEX1_OUTPUT VS1Tex (
      float4 Pos    : POSITION           // f̒_
     ,float2 Tex    : TEXCOORD0	         // eNX`W
){
    VSTEX1_OUTPUT Out;
    
    Out.Pos = Pos;  
    Out.Tex0 = Tex;
    
    return Out;
}


VSTLV_OUTPUT VSTLV (
      float4 Pos    : POSITION           // f̒_
    ,float4  Diffuse : COLOR0
    ,float2 Tex    : TEXCOORD0	         // eNX`W
){
    VSTLV_OUTPUT Out;
    
    Out.Pos = Pos;
    Out.Diffuse = Diffuse;
    Out.Tex0 = Tex;
    
    return Out;
}


// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
PS_OUTPUT PSDummy( VSTEX1_OUTPUT In )
{
	PS_OUTPUT Out;

	float4 vSample = tex2D( SampUser0Point, In.Tex0 );
	Out.Color = vSample * userFL4_0;

	return Out;
}


//////////////////////////////////////////////
// user`eNjbN
//////////////////////////////////////////////

// ------------------------------------------------------------
// _VF[_vO
// ------------------------------------------------------------

// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------

//eNX`XvbeBO
// seasalt 2012. 3 - 2012. 5

PS_OUTPUT PSUserBlend( VSTEX1_OUTPUT In )
{
	PS_OUTPUT Out;

	float4 a1;
	float3 a2,a3,a4,a5;
	float3 b1,b2,b3,b4;
	float2 c1,c2,c3,c4;
	float2 d1;

	c1.x = In.Tex0.x * userFL4_0.x;
	c1.y = In.Tex0.y * userFL4_0.x;

	c2.x = In.Tex0.x * userFL4_0.y;
	c2.y = In.Tex0.y * userFL4_0.y;

	c3.x = In.Tex0.x * userFL4_0.z;
	c3.y = In.Tex0.y * userFL4_0.z;

	c4.x = In.Tex0.x * userFL4_0.w;
	c4.y = In.Tex0.y * userFL4_0.w;

	d1.x =( In.Tex0.x * ( userFL4_1.z - userFL4_1.x ) ) + userFL4_1.x;
	d1.y =( In.Tex0.y * ( userFL4_1.w - userFL4_1.y ) ) + userFL4_1.y;

	a1 = tex2D( SampUser0Linear, d1 );	// f[^eNX`
	a2 = tex2D( SampUser1Point, c1 ).rgb; // RFɊ蓖ĂꂽeNX`
	a3 = tex2D( SampUser2Point, c2 ).rgb; // G
	a4 = tex2D( SampUser3Point, c3 ).rgb; // B
	a5 = tex2D( SampUser4Point, c4 ).rgb; // A

	b1 = a2 * ( a1.r, a1.r, a1.r );
	b2 = a3 * ( a1.g, a1.g, a1.g );
	b3 = a4 * ( a1.b, a1.b, a1.b );
	b4 = a5 * ( 1.0f-a1.a, 1.0f-a1.a, 1.0f-a1.a );	// At@l̂ݔ]( 摜쐬₷邽 )
	
	Out.Color.rgb = b1 + b2 + b3 + b4;
	Out.Color.a = 1.0f;

	return Out;
}

PS_OUTPUT PSUserBlendEx( VSTEX1_OUTPUT In )
{
	PS_OUTPUT Out;

	float4 a1;
	float3 a2,a3,a4,a5;
	float3 b1,b2,b3,b4;
	float2 c1,c2,c3,c4;
	float2 d1;

	c1.x = In.Tex0.x * userFL4_0.x;
	c1.y = In.Tex0.y * userFL4_0.x;

	c2.x = In.Tex0.x * userFL4_0.y;
	c2.y = In.Tex0.y * userFL4_0.y;

	c3.x = In.Tex0.x * userFL4_0.z;
	c3.y = In.Tex0.y * userFL4_0.z;

	c4.x = In.Tex0.x * userFL4_0.w;
	c4.y = In.Tex0.y * userFL4_0.w;

	d1.x =( In.Tex0.x * ( userFL4_1.z - userFL4_1.x ) ) + userFL4_1.x;
	d1.y =( In.Tex0.y * ( userFL4_1.w - userFL4_1.y ) ) + userFL4_1.y;

	a1 = tex2D( SampUser0Linear, d1 );	// f[^eNX`
	a2 = tex2D( SampUser1Point, c1 ).rgb *0.7+ tex2D( SampUser1Linear, In.Tex0 ).rgb*0.3; // ꖇ(R)̃eNX`̐F
	a3 = tex2D( SampUser2Point, c2 ).rgb *0.7+ tex2D( SampUser2Linear, In.Tex0 ).rgb*0.3; // 񖇖(G)̃eNX`̐F
	a4 = tex2D( SampUser3Point, c3 ).rgb *0.7+ tex2D( SampUser3Linear, In.Tex0 ).rgb*0.3; // O(B)̃eNX`̐F
	a5 = tex2D( SampUser4Point, c4 ).rgb *0.7+ tex2D( SampUser4Linear, In.Tex0 ).rgb*0.3; // l(A)̃eNX`̐F
	

	b1 = a2 * ( a1.r, a1.r, a1.r );
	b2 = a3 * ( a1.g, a1.g, a1.g );
	b3 = a4 * ( a1.b, a1.b, a1.b );
	b4 = a5 * ( 1.0f-a1.a, 1.0f-a1.a, 1.0f-a1.a );	// At@l̂ݔ]( 摜쐬₷邽 )
	
	Out.Color.rgb = b1 + b2 + b3 + b4;
	Out.Color.a =1.0f;

	return Out;
}


//////////////////////////////////////////////
// user`eNjbN
//////////////////////////////////////////////
technique PostEffectUser0
{
	pass P0
	{
		VertexShader = compile vs_2_0 VS1Tex();
		PixelShader = compile ps_2_0 PSUserBlend();
	}
}

technique PostEffectUser1
{
	pass P0
	{
		VertexShader = compile vs_2_0 VS1Tex();
		PixelShader = compile ps_2_0 PSUserBlendEx();
	}
}

technique PostEffectUser2
{
	pass P0
	{
		VertexShader = compile vs_2_0 VS1Tex();
		PixelShader = compile ps_2_0 PSDummy();
	}
}
technique PostEffectUser3
{
	pass P0
	{
		VertexShader = compile vs_2_0 VS1Tex();
		PixelShader = compile ps_2_0 PSDummy();
	}
}
technique PostEffectUser4
{
	pass P0
	{
		VertexShader = compile vs_2_0 VS1Tex();
		PixelShader = compile ps_2_0 PSDummy();
	}
}

